<template>
  <q-page padding>
    <div class="text-center">
      <q-img src="public/img/openscouts.png" width="20%"></q-img>
    </div>
    <div class="q-pa-md">
      <q-banner rounded class="bg-red text-white text-center">
        Solo se permitirá el registro de los miembros afiliados a SAAC.
      </q-banner>
    </div>
    <q-form
      v-if="paso === 1"
      class="q-ma-md q-gutter-sm"
      @submit="validarDocumento"
      autocomplete="off"
    >
      <q-input
        autofocus
        v-model="formData.documento"
        label="Nro de Documento*"
        type="number"
      >
        <template v-slot:append>
          <q-icon name="person" />
        </template>
      </q-input>

      <q-btn @click="validarDocumento" class="full-width" color="green">
        Validar Documento
      </q-btn>
    </q-form>
    <!-------------------------------------------------------------------------------------------------------->
    <!------------------------------- FORMULARIO DE REGISTRO !!  --------------------------------------------->
    <!-------------------------------------------------------------------------------------------------------->

    <q-form
      v-if="paso === 2"
      class="q-ma-md q-gutter-sm"
      @submit="registrar"
      autocomplete="off"
    >
      <div class="row q-col-gutter-xs">
        <div class="col">
          <q-input
            disable
            v-model="formData.documento"
            label="Nro de Documento*"
            type="number"
            :error="validacion.has('documento')"
            :error-message="validacion.first('documento')"
          >
            <template v-slot:append>
              <q-icon name="numbers" />
            </template>
          </q-input>
        </div>
      </div>

      <div
        class="row q-col-gutter-xs"
        v-if="!formData.organismo_id && formData.existe"
      >
        <div class="col">
          <q-input
            v-model="formData.zona"
            label="Zona"
            type="number"
            :error="validacion.has('zona')"
            :error-message="validacion.first('zona')"
          />
        </div>
        <div class="col">
          <q-input
            v-model="formData.distrito"
            label="Distrito"
            type="number"
            :error="validacion.has('distrito')"
            :error-message="validacion.first('distrito')"
          />
        </div>
        <div class="col">
          <q-input
            v-model="formData.organismo_id"
            label="Nro Grupo"
            type="number"
            :error="validacion.has('organismo_id')"
            :error-message="validacion.first('organismo_id')"
          />
        </div>
      </div>
      <div class="row q-col-gutter-xs">
        <div class="col-12">
          <q-input
            v-if="!formData.organismo_id && formData.existe"
            v-model="formData.organismo"
            label="Grupo"
            :error="validacion.has('organismo')"
            :error-message="validacion.first('organismo')"
          />
          <q-input
            disable
            v-if="formData.organismo"
            v-model="formData.organismo"
            label="Grupo"
            :error="validacion.has('organismo')"
            :error-message="validacion.first('organismo')"
          />
        </div>
        <div class="col-12">
          <q-input
            v-model="formData.nombre"
            label="Nombre"
            :error="validacion.has('nombre')"
            :error-message="validacion.first('nombre')"
          >
            <template v-slot:append>
              <q-icon name="person" />
            </template>
          </q-input>
        </div>

        <div class="col-12">
          <q-input
            v-model="formData.apellido"
            label="Apellido"
            :error="validacion.has('apellido')"
            :error-message="validacion.first('apellido')"
          >
            <template v-slot:append>
              <q-icon name="group" />
            </template>
          </q-input>
        </div>
      </div>
      <div class="row q-col-gutter-xs">
        <div class="col-4">
          <q-select
            filled
            v-model="formData.dia"
            :options="[
              ...Array(31)
                .keys()
            ].map((i:number) => i + 1)"
            label="Dia"
            :error="validacion.has('dia')"
            :error-message="validacion.first('dia')"
          />
        </div>
        <div class="col-4">
          <q-select
            filled
            v-model="formData.mes"
            :options="meses"
            label="Mes"
            emit-value
            map-options
            :error="validacion.has('mes')"
            :error-message="validacion.first('mes')"
          />
        </div>
        <div class="col-4">
          <q-select
            filled
            v-model="formData.anio"
            :options="[
              ...Array(70)
                .keys()
            ].map((i:number) => i + 1940)"
            label="Año"
            :error="validacion.has('anio')"
            :error-message="validacion.first('anio')"
          />
        </div>
      </div>
      <div class="row q-col-gutter-xs">
        <div class="col-12">
          <q-input
            v-model="formData.celular"
            label="Celular"
            :error="validacion.has('celular')"
            :error-message="validacion.first('celular')"
          >
            <template v-slot:append>
              <q-icon name="wifi_calling_3" />
            </template>
          </q-input>
        </div>
        <div class="col-12">
          <q-input
            v-model="formData.email"
            label="Email"
            type="email"
            :error="validacion.has('email')"
            :error-message="validacion.first('email')"
          >
            <template v-slot:append>
              <q-icon name="alternate_email" />
            </template>
          </q-input>
        </div>
        <div class="col-12">
          <q-input
            v-model="formData.password"
            label="Contraseña"
            :type="isPwd ? 'password' : 'text'"
            :error="validacion.has('password')"
            :error-message="validacion.first('password')"
          >
            <template v-slot:append>
              <q-icon
                :name="isPwd ? 'visibility_off' : 'visibility'"
                class="cursor-pointer"
                @click="isPwd = !isPwd"
              />
            </template>
          </q-input>
        </div>
        <div class="col-12">
          <q-input
            v-model="formData.password_confirmation"
            label="Repetir la Contraseña"
            :type="isPwd2 ? 'password' : 'text'"
            :error="validacion.has('password_confirmation')"
            :error-message="validacion.first('password_confirmation')"
          >
            <template v-slot:append>
              <q-icon
                :name="isPwd2 ? 'visibility_off' : 'visibility'"
                class="cursor-pointer"
                @click="isPwd2 = !isPwd2"
              />
            </template>
          </q-input>
        </div>
      </div>
      <div class="row q-col-gutter-xs">
        <div class="col-12">
          <q-btn @click="registrar" class="full-width" color="green">
            Confirmar Registro
          </q-btn>
        </div>
      </div>
    </q-form>

    <Loading :showing="loading" />
  </q-page>
</template>

<script lang="ts">
import { api, validacion } from 'src/boot/axios/index';
import { AxiosResponse } from 'axios';
import { useRouter } from 'vue-router';

import { defineComponent, ref, reactive } from 'vue';
import { useQuasar } from 'quasar';
import Loading from 'src/components/Loading.vue';
interface RegistroInterface {
  documento: number | null;
  // nuevo: boolean | null;
  organismo: string | null;
  organismo_id: number | null;
  // funcion: string;
  apellido: string | null;
  nombre: string | null;
  anio: number | null;
  mes: number | null;
  dia: number | null;
  email: string | null;
  celular: string | null;
  password: string | null;
  password_confirmation: string | null;
  zona: string | null;
  distrito: string | null;
}

export default defineComponent({
  name: 'RegistroPage',
  components: { Loading },
  setup() {
    const loading = ref(false);
    const router = useRouter();

    const paso = ref(1);
    const $q = useQuasar();
    const isPwd = ref(true);
    const isPwd2 = ref(true);

    const meses = [
      { value: 1, label: 'Enero' },
      { value: 2, label: 'Febrero' },
      { value: 3, label: 'Marzo' },
      { value: 4, label: 'Abril' },
      { value: 5, label: 'Mayo' },
      { value: 6, label: 'Junio' },
      { value: 7, label: 'Julio' },
      { value: 8, label: 'Agosto' },
      { value: 9, label: 'Septiembre' },
      { value: 10, label: 'Octubre' },
      { value: 11, label: 'Noviembre' },
      { value: 12, label: 'Diciembre' },
    ];

    const formData: RegistroInterface = reactive<RegistroInterface>({
      documento: null,
      // nuevo: null,
      organismo: null,
      organismo_id: null,
      distrito: null,
      zona: null,
      // funcion: string;
      apellido: '',
      nombre: '',
      anio: null,
      mes: null,
      dia: null,
      email: '',
      celular: '',
      password: '',
      existe: false,
      password_confirmation: '',
    });

    function validarDocumento() {
      loading.value = true;

      api
        .post('/api/auth/valida_documento', {
          documento: formData.documento,
        })
        .then((response: AxiosResponse) => {
          loading.value = false;
          paso.value = 2;
          formData.organismo = response.data.organismo;
          formData.organismo_id = response.data.organismo_id;
          if (response.data.nombre) {
            formData.nombre = response.data.nombre;
          }
          if (response.data.apellido) {
            formData.apellido = response.data.apellido;
          }
        })
        .finally(() => {
          loading.value = false;
        });
    }

    function registrar() {
      if (formData.password !== formData.password_confirmation) {
        $q.notify({
          message: 'Las contraseñas no son similares',
          color: 'red',
          position: 'top',
        });
        return;
      }

      loading.value = true;
      api
        .post('/api/auth/registrarse', formData)
        .then(() => {
          // Si da todo ok .. HACER LOGIN DE UNA !!!
          return router.push({ path: '/' });
        })
        .finally(() => {
          loading.value = false;
        });
    }

    return {
      validacion,
      loading,
      isPwd,
      isPwd2,
      paso,
      meses,
      formData,
      validarDocumento,
      registrar,
    };
  },
});
</script>
